package org.processmining.earthmoversstochasticconformancechecking.parameters;

import org.deckfour.xes.classification.XEventClassifier;
import org.processmining.earthmoversstochasticconformancechecking.distancematrix.DistanceMatrix;

public abstract class EMSCParametersLogModelAbstract extends EMSCParametersAbstract implements EMSCParametersLogModel {
	private XEventClassifier eventClassifier;
	private TerminationStrategyImpl terminationStrategy;

	public EMSCParametersLogModelAbstract(DistanceMatrix distanceMatrix, XEventClassifier eventClassifier,
			TerminationStrategyImpl terminationStrategy, boolean debug, boolean computeStochasticTraceAlignments) {
		super(debug, computeStochasticTraceAlignments);
		this.eventClassifier = eventClassifier;
		this.terminationStrategy = terminationStrategy;
		this.setDebug(debug);
		setDistanceMatrix(distanceMatrix);
	}

	public XEventClassifier getClassifierA() {
		return eventClassifier;
	}

	public void setLogClassifier(XEventClassifier eventClassifier) {
		this.eventClassifier = eventClassifier;
	}

	public TerminationStrategyImpl getTerminationStrategyB() {
		return terminationStrategy;
	}

	public void setModelTerminationStrategy(TerminationStrategyImpl terminationStrategy) {
		this.terminationStrategy = terminationStrategy;
	}
}