package org.processmining.earthmoversstochasticconformancechecking.parameters;

import org.processmining.earthmoversstochasticconformancechecking.distancematrix.DistanceMatrix;

public class EMSCParametersModelModelAbstract extends EMSCParametersAbstract implements EMSCParametersModelModel {
	private TerminationStrategyImpl strategyA;
	private TerminationStrategyImpl strategyB;

	public EMSCParametersModelModelAbstract(DistanceMatrix distanceMatrix, TerminationStrategyImpl strategyA,
			TerminationStrategyImpl strategyB, boolean debug, boolean computeStochasticTraceAlignments) {
		super(debug, computeStochasticTraceAlignments);
		this.strategyA = strategyA;
		this.strategyB = strategyB;
		setDistanceMatrix(distanceMatrix);
	}

	public TerminationStrategyImpl getTerminationStrategyA() {
		return strategyA;
	}

	public void setTerminationStrategyA(TerminationStrategyImpl terminationStrategyA) {
		this.strategyA = terminationStrategyA;
	}

	public TerminationStrategyImpl getTerminationStrategyB() {
		return strategyB;
	}

	public void setTerminationStrategyB(TerminationStrategyImpl terminationStrategyB) {
		this.strategyB = terminationStrategyB;
	}

}