package org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage;

import java.util.Iterator;

public interface StochasticTraceIterator extends Iterator<String[]> {

	/**
	 * 
	 * @return A trace of the -visible- steps taken in the trace of a stochastic
	 *         language. If result is not needed, please use nextIntegerTrace().
	 */
	public String[] next();

	/**
	 * 
	 * @return A trace of the -visible- steps taken in the trace of a stochastic
	 *         language.
	 */
	public int[] nextIntegerTrace();

	/**
	 * 
	 * @return The probability of the last trace returned by next().
	 */
	public double getProbability();

}