package org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.log;

import org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.Activity2IndexKey;
import org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.StochasticTraceIterator;
import org.processmining.framework.plugin.ProMCanceller;

public class StochasticLanguageLogNormalise {
	public static StochasticLanguageLog normalise(final StochasticLanguageLog language, ProMCanceller canceller) {

		double sum = 0;
		for (StochasticTraceIterator it = language.iterator(); it.hasNext();) {
			it.next();
			sum += it.getProbability();

			if (canceller.isCancelled()) {
				return null;
			}
		}
		final double sum2 = sum;

		return new StochasticLanguageLog() {
			public StochasticTraceIterator iterator() {
				final StochasticTraceIterator it = language.iterator();
				return new StochasticTraceIterator() {

					public String[] next() {
						return it.next();
					}

					public boolean hasNext() {
						return it.hasNext();
					}

					public double getProbability() {
						return it.getProbability() / sum2;
					}

					public int[] nextIntegerTrace() {
						return it.nextIntegerTrace();
					}
				};
			}

			public int size() {
				return language.size();
			}

			public String[] getTraceString(int traceIndex) {
				return language.getTraceString(traceIndex);
			}

			public int[] getTrace(int traceIndex) {
				return language.getTrace(traceIndex);
			}

			public Activity2IndexKey getActivityKey() {
				return language.getActivityKey();
			}

		};
	}
}
