package org.processmining.earthmoversstochasticconformancechecking.tracealignments;

import java.util.Iterator;

import org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.StochasticLanguage;

public interface StochasticTraceAlignments<L, M> extends Iterable<StochasticTraceAlignment<L, M>> {

	/**
	 * Get the EMSC value (similarity). Compute 1 - similarity = distance.
	 * 
	 * @return
	 */
	public double getSimilarity();

	public interface StochasticTraceAlignmentIterator<L, M> extends Iterator<StochasticTraceAlignment<L, M>> {
		public double getProbability();

		public String[] getTraceA();

		public String[] getTraceB();

		public int getTraceAIndex();

		public int getTraceBIndex();
	}

	@Override
	public StochasticTraceAlignmentIterator<L, M> iterator();

	/**
	 * The first language.
	 * 
	 * @return
	 */
	public StochasticLanguage getLanguageA();

	/**
	 * The second language.
	 * 
	 * @return
	 */
	public StochasticLanguage getLanguageB();

}