package org.processmining.earthmoversstochasticconformancechecking.tracealignments;

import org.processmining.earthmoversstochasticconformancechecking.helperclasses.TransitionMap;
import org.processmining.earthmoversstochasticconformancechecking.reallocationmatrix.ReallocationMatrix;
import org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.log.StochasticLanguageLog;
import org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.model.StochasticLanguageModel;
import org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.model.StochasticPath;
import org.processmining.earthmoversstochasticconformancechecking.stochasticlanguage.model.StochasticTransition;
import org.processmining.models.graphbased.directed.petrinet.StochasticNet;

/**
 * Wrapper class as ProM does not support generics.
 * 
 * @author sander
 *
 */
public class StochasticTraceAlignmentsLogModel extends StochasticTraceAlignmentsAbstract<String, StochasticTransition> {

	private final StochasticNet net;
	private final TransitionMap transitionMap;
	private final StochasticLanguageModel languageB;

	public StochasticTraceAlignmentsLogModel(ReallocationMatrix relocationMatrix, double similarity, StochasticNet net,
			TransitionMap transitionMap, StochasticLanguageLog languageA, StochasticLanguageModel languageB) {
		super(relocationMatrix, similarity, languageA, languageB);
		this.net = net;
		this.transitionMap = transitionMap;
		this.languageB = languageB;
	}

	public StochasticNet getStochasticNet() {
		return net;
	}

	public TransitionMap getTransitionMap() {
		return transitionMap;
	}

	@Override
	public EditIteratorLogModel iterator() {
		return new EditIteratorLogModel();
	}

	public class EditIteratorLogModel extends EditIterator {
		public StochasticPath getStochasticPathB() {
			int[] path = languageB.getPath(now);
			return languageB.getTransitionKey().getStochasticPath(path);
		}
	}

}